use std::collections::HashMap;

use serde::Deserialize;

use crate::model::icon_descriptor::IconDescriptor;

#[derive(Debug, Deserialize)]
pub struct PlayPauseConfig {
    #[serde(default)]
    pub icon: HashMap<PlayPauseState, IconDescriptor>,
    #[serde(default)]
    pub action: PlayPauseAction,
}

#[derive(Debug, Default, Eq, PartialEq, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum PlayPauseAction {
    #[default]
    Toggle,
    Play,
    Pause,
}

#[derive(Debug, Deserialize)]
pub struct PreviousAndNextConfig {
    #[serde(default)]
    pub icon: HashMap<PreviousAndNextState, IconDescriptor>,
}

#[derive(Debug, Eq, PartialEq, Hash, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum PlayPauseState {
    Inactive,
    Playing,
    Paused,
}

#[derive(Debug, Eq, PartialEq, Hash, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum PreviousAndNextState {
    Inactive,
    Active,
}
