use enum_map::Enum;
use serde::Deserialize;

pub mod config;
pub mod geometry;
pub mod icon_descriptor;
pub mod image_filter;
pub mod key_modes;
pub mod key_page;
pub mod knob_modes;
pub mod knob_page;
pub mod rgb;

#[derive(Debug, Eq, PartialEq, Hash, Clone, Copy, Deserialize, Enum)]
#[serde(rename_all = "kebab-case")]
pub enum KnobPosition {
    LeftTop,
    LeftMiddle,
    LeftBottom,
    RightTop,
    RightMiddle,
    RightBottom,
}

#[derive(Debug, Eq, PartialEq, Hash, Clone, Copy, Deserialize, Enum)]
pub enum ButtonPosition {
    #[serde(rename = "0")]
    N0,
    #[serde(rename = "1")]
    N1,
    #[serde(rename = "2")]
    N2,
    #[serde(rename = "3")]
    N3,
    #[serde(rename = "4")]
    N4,
    #[serde(rename = "5")]
    N5,
    #[serde(rename = "6")]
    N6,
    #[serde(rename = "7")]
    N7,
}
