use std::collections::HashMap;
use std::rc::Rc;

use enum_map::EnumMap;

use crate::model::icon_descriptor::IconDescriptor;
use crate::model::KnobPosition;

#[derive(Debug)]
pub struct State {
    pub active_key_page: Rc<KeyPage>,
    pub active_knob_page: Rc<KnobPage>,
    pub key_pages_by_id: HashMap<String, Rc<KeyPage>>,
    pub knob_pages_by_id: HashMap<String, Rc<KnobPage>>,
}

#[derive(Debug)]
pub struct KeyPage {
    pub id: String,
}

#[derive(Debug)]
pub struct KnobPage {
    pub id: String,
    pub knobs_by_position: EnumMap<KnobPosition, Option<Knob>>,
}

#[derive(Debug)]
pub struct Knob {
    pub id: KnobPosition,
    pub icon: IconDescriptor,
    pub label: String,
    pub value: f32,
}
